<?php

namespace Drupal\nextjs;

use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Entity\EntityListBuilder;

/**
 * Provides a list controller for the nextjs_environment entity type.
 */
class NextjsEnvironmentListBuilder extends EntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function render() {
    $build['table'] = parent::render();

    $total = $this->getStorage()
      ->getQuery()
      ->accessCheck(FALSE)
      ->count()
      ->execute();

    $build['summary']['#markup'] = $this->t('Total Next.js environments: @total', ['@total' => $total]);
    return $build;
  }

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['id'] = $this->t('ID');
    $header['label'] = $this->t('Label');
    $header['value'] = $this->t('Value');
    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    /** @var \Drupal\nextjs\Entity\NextjsEnvironmentInterface $entity */

    if ($entity->getType() === 'host') {
      $value = $entity->getHost();
    }

    $row['id'] = $entity->id();
    $row['label'] = $entity->label();
    $row['value'] = $value;

    return $row + parent::buildRow($entity);
  }

}
