<?php

namespace Drupal\nextjs\Repository;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Drupal\nextjs\Entity\NextjsEnvironmentInterface;

/**
 * Repository for nextjs_environment entities.
 */
class NextjsEnvironmentRepository implements NextjsEnvironmentRepositoryInterface {

  /**
   * Construct new NextjsEnvironmentRepository.
   */
  public function __construct(
    protected EntityTypeManagerInterface $entityTypeManager,
  ) {}

  /**
   * {@inheritdoc}
   */
  public function getEnvironments(array $ids = NULL): array {
    return $this->entityTypeManager->getStorage('nextjs_environment')->loadMultiple($ids);
  }

  /**
   * {@inheritdoc}
   */
  public function getEnvironment(string $id): ?NextjsEnvironmentInterface {
    return $this->entityTypeManager->getStorage('nextjs_environment')->load($id);
  }

  /**
   * {@inheritdoc}
   */
  public function getEnvironmentNamesAsOptions(): array {
    $options = [];

    foreach ($this->getEnvironments() as $env) {
      $options[$env->id()] = $env->label();
    }

    return $options;
  }

}
