<?php

namespace Drupal\nextjs\Repository;

use Drupal\nextjs\Entity\NextjsEnvironmentInterface;

/**
 * Interface that defines a NextjsEnvironmentRepository.
 */
interface NextjsEnvironmentRepositoryInterface {

  /**
   * Get all defined environments.
   *
   * @return \Drupal\nextjs\Entity\NextjsEnvironmentInterface[]
   *   Array of environments.
   */
  public function getEnvironments(array $ids = NULL): array;

  /**
   * Get a single environment by id.
   */
  public function getEnvironment(string $id): ?NextjsEnvironmentInterface;

  /**
   * Get environments as an option array.
   */
  public function getEnvironmentNamesAsOptions(): array;

}
